;+--------------------------------------------+
;|   My port of SPRXOR to SPRXOR 16           |
;|   Thanks to Movax for the original SPRXOR  |
;|   By Kerm Martian, Kerm_Martian@yahoo.com  |
;|   http://www.cemetech.tk                   |
;|   v1.2                                     |
;+--------------------------------------------+
SPRXOR16:
    push bc
    ld hl,0
    ld d,0
    add hl,de
    add hl,de
    add hl,de
    add hl,hl
    add hl,hl
    ld d,0
    ld e,a
    srl e
    srl e
    srl e
    add hl,de
    ld de,8e29h
    add hl,de
    ld b,00000111b
    and b
    or a
    jp z,ALIGN16
    pop ix
    ld d,a
    ld e,16
LILOP16:
    ld b,(ix+0)
    ld c,0
    push de
SHLOP16:
    srl b
    rr c
    dec d
    jp nz,SHLOP16
    pop de
    push de
    ld a,b
    xor (hl)
    ld (hl),a
    inc hl
    ld a,c
    xor (hl)
    ld (hl),a
;---
    inc ix
    ld b,(ix+0)
    ld c,0
SHLOP216:
    srl b
    rr c
    dec d
    jp nz,SHLOP216
    pop de
    ld a,b
    xor (hl)
    ld (hl),a
    inc hl
    ld a,c
    xor (hl)
    ld (hl),a
;---
    ld bc,10
    add hl,bc
    inc ix
    dec e
    jp nz,LILOP16
    ret
ALIGN16:
    pop de
    ld b,16
ALOP116:
    ld a,(de)
    xor (hl)
    ld (hl),a
    inc de
    inc hl
    ld a,(de)
    xor (hl)
    ld (hl),a
    inc de
    push bc
    ld bc,11
    add hl,bc
    pop bc
    djnz ALOP116
    ret
